# This is an auto-generated Django model module.
# You'll have to do the following manually to clean this up:
#   * Rearrange models' order
#   * Make sure each model has one field with primary_key=True
#   * Make sure each ForeignKey and OneToOneField has `on_delete` set to the desired behavior
#   * Remove `managed = False` lines if you wish to allow Django to create, modify, and delete the table
# Feel free to rename the models, but don't rename db_table values or field names.
from django.db import models


class AuthGroup(models.Model):
    name = models.CharField(unique=True, max_length=150)

    class Meta:
        managed = False
        db_table = 'auth_group'


class AuthGroupPermissions(models.Model):
    id = models.BigAutoField(primary_key=True)
    group = models.ForeignKey(AuthGroup, models.DO_NOTHING)
    permission = models.ForeignKey('AuthPermission', models.DO_NOTHING)

    class Meta:
        managed = False
        db_table = 'auth_group_permissions'
        unique_together = (('group', 'permission'),)


class AuthPermission(models.Model):
    name = models.CharField(max_length=255)
    content_type = models.ForeignKey('DjangoContentType', models.DO_NOTHING)
    codename = models.CharField(max_length=100)

    class Meta:
        managed = False
        db_table = 'auth_permission'
        unique_together = (('content_type', 'codename'),)


class AuthUser(models.Model):
    password = models.CharField(max_length=128)
    last_login = models.DateTimeField(blank=True, null=True)
    is_superuser = models.IntegerField()
    username = models.CharField(unique=True, max_length=150)
    first_name = models.CharField(max_length=150)
    last_name = models.CharField(max_length=150)
    email = models.CharField(max_length=254)
    is_staff = models.IntegerField()
    is_active = models.IntegerField()
    date_joined = models.DateTimeField()

    class Meta:
        managed = False
        db_table = 'auth_user'


class AuthUserGroups(models.Model):
    id = models.BigAutoField(primary_key=True)
    user = models.ForeignKey(AuthUser, models.DO_NOTHING)
    group = models.ForeignKey(AuthGroup, models.DO_NOTHING)

    class Meta:
        managed = False
        db_table = 'auth_user_groups'
        unique_together = (('user', 'group'),)


class AuthUserUserPermissions(models.Model):
    id = models.BigAutoField(primary_key=True)
    user = models.ForeignKey(AuthUser, models.DO_NOTHING)
    permission = models.ForeignKey(AuthPermission, models.DO_NOTHING)

    class Meta:
        managed = False
        db_table = 'auth_user_user_permissions'
        unique_together = (('user', 'permission'),)


class Buffer(models.Model):
    bufuniqueid = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    customer_id = models.CharField(max_length=255)
    buf_name = models.CharField(max_length=255)
    actualvalue = models.CharField(max_length=255, blank=True, null=True)
    description = models.CharField(max_length=255, blank=True, null=True)
    time = models.CharField(max_length=255, blank=True, null=True)
    visiblelevel = models.CharField(max_length=255, blank=True, null=True)
    highalertvalue = models.CharField(max_length=255, blank=True, null=True)
    created_at = models.CharField(max_length=255, blank=True, null=True)

    def __str__(self):
        return self.buf_name

    class Meta:
        managed = False
        db_table = 'buffer'
        verbose_name_plural = 'Buffer'


class Cpumetrics(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    cpuuniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    user = models.FloatField()
    sys = models.FloatField()
    iowait = models.FloatField()
    steal = models.FloatField()
    idle = models.FloatField()
    created_at = models.CharField(max_length=255)
    nice = models.CharField(max_length=255, blank=True, null=True)

    def __str__(self):
        return "CPU Metrics"    
    class Meta:
        managed = False
        db_table = 'cpumetrics'
        verbose_name_plural = 'CPUMetrics'


class CustomerMang(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    cusuniqueid = models.CharField(unique=True, max_length=255)
    cuscomname = models.CharField(max_length=255)
    cuscontactname = models.CharField(max_length=255)
    cusmobnum = models.CharField(max_length=255)
    cusaddress = models.TextField()
    cusemail = models.CharField(max_length=255)
    cuspassword = models.CharField(max_length=255)
    isverified = models.IntegerField()
    status = models.IntegerField()
    created_at = models.CharField(max_length=255)
    modified_at = models.CharField(max_length=255)
    sub_by = models.CharField(max_length=255)
    
    def __str__(self):
        return self.cuscomname 
    class Meta:
        managed = False
        db_table = 'customer_mang'
        verbose_name_plural = 'Customer Management'


class DjangoAdminLog(models.Model):
    action_time = models.DateTimeField()
    object_id = models.TextField(blank=True, null=True)
    object_repr = models.CharField(max_length=200)
    action_flag = models.PositiveSmallIntegerField()
    change_message = models.TextField()
    content_type = models.ForeignKey('DjangoContentType', models.DO_NOTHING, blank=True, null=True)
    user = models.ForeignKey(AuthUser, models.DO_NOTHING)

    class Meta:
        managed = False
        db_table = 'django_admin_log'


class DjangoContentType(models.Model):
    app_label = models.CharField(max_length=100)
    model = models.CharField(max_length=100)

    class Meta:
        managed = False
        db_table = 'django_content_type'
        unique_together = (('app_label', 'model'),)


class DjangoMigrations(models.Model):
    id = models.BigAutoField(primary_key=True)
    app = models.CharField(max_length=255)
    name = models.CharField(max_length=255)
    applied = models.DateTimeField()

    class Meta:
        managed = False
        db_table = 'django_migrations'


class DjangoSession(models.Model):
    session_key = models.CharField(primary_key=True, max_length=40)
    session_data = models.TextField()
    expire_date = models.DateTimeField()

    class Meta:
        managed = False
        db_table = 'django_session'


class Dumps(models.Model):
    dumpsuniqueid = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    customer_id = models.CharField(max_length=255)
    dumps_name = models.CharField(max_length=255)
    actualvalue = models.CharField(max_length=255, blank=True, null=True)
    description = models.CharField(max_length=255, blank=True, null=True)
    time = models.CharField(max_length=255, blank=True, null=True)
    visiblelevel = models.CharField(max_length=255, blank=True, null=True)
    highalertvalue = models.CharField(max_length=255, blank=True, null=True)
    created_at = models.CharField(max_length=255, blank=True, null=True)

    def __str__(self):
        return self.dumps_name 
    class Meta:
        managed = False
        db_table = 'dumps'
        verbose_name_plural = 'Dumps'


class Fsmetircs(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    fsuniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    filesys = models.CharField(max_length=255)
    size = models.CharField(max_length=255)
    used = models.CharField(max_length=255)
    available = models.CharField(max_length=255)
    perc = models.CharField(max_length=255, blank=True, null=True)
    mounted_on = models.CharField(db_column='Mounted_On', max_length=255, blank=True, null=True)  # Field name made lowercase.
    created_at = models.CharField(max_length=255)
    def __str__(self):
        return "File System" 
    class Meta:
        managed = False
        db_table = 'fsmetircs'
        verbose_name_plural = 'File Sys Metrics'


class Instancelist(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    insuniqueid = models.CharField(unique=True, max_length=255)
    system_id = models.CharField(max_length=255)
    customer_id = models.CharField(max_length=255)
    sysname = models.CharField(max_length=255)
    instanceno = models.IntegerField()
    http_port = models.IntegerField()
    https_port = models.IntegerField()
    start_priority = models.IntegerField()
    instancewsdlurl = models.CharField(max_length=255)
    features = models.CharField(max_length=255)
    status = models.CharField(max_length=255)
    created_at = models.CharField(max_length=255)
    modified_at = models.CharField(max_length=255)

    def __str__(self):
        return "Instance" 
    class Meta:
        managed = False
        db_table = 'instancelist'
        verbose_name_plural = 'Istance List'


class Memorymetrics(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    memuniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    memtype = models.CharField(max_length=255)
    total = models.CharField(max_length=255)
    used = models.CharField(max_length=255)
    free = models.CharField(max_length=255)
    shared = models.CharField(max_length=255)
    cache = models.CharField(max_length=255)
    available = models.CharField(max_length=255)
    port = models.IntegerField(blank=True, null=True)
    created_at = models.CharField(max_length=255)
    def __str__(self):
        return "Memory Metric" 
    class Meta:
        managed = False
        db_table = 'memorymetrics'
        verbose_name_plural = 'Memory Metrics'


class ProcessList(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    processuniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    pname = models.CharField(max_length=255)
    pdesc = models.CharField(max_length=255)
    dispstatus = models.CharField(max_length=255)
    stime = models.CharField(max_length=255)
    created_at = models.CharField(max_length=255)
    def __str__(self):
        return self.pname 
    class Meta:
        managed = False
        db_table = 'process_list'
        verbose_name_plural = 'Process List'


class Responsetimes(models.Model):
    resuniqueid = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    customer_id = models.CharField(max_length=255)
    response_name = models.CharField(max_length=255)
    actualvalue = models.CharField(max_length=255, blank=True, null=True)
    description = models.CharField(max_length=255, blank=True, null=True)
    time = models.CharField(max_length=255, blank=True, null=True)
    visiblelevel = models.CharField(max_length=255, blank=True, null=True)
    highalertvalue = models.CharField(max_length=255, blank=True, null=True)
    created_at = models.CharField(max_length=255, blank=True, null=True)
    def __str__(self):
        return self.response_name 
    class Meta:
        managed = False
        db_table = 'responsetimes'
        verbose_name_plural = 'Response Times'


class Spool(models.Model):
    spooluniqueid = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    customer_id = models.CharField(max_length=255)
    spool_name = models.CharField(max_length=255)
    actualvalue = models.CharField(max_length=255, blank=True, null=True)
    description = models.CharField(max_length=255, blank=True, null=True)
    time = models.CharField(max_length=255, blank=True, null=True)
    visiblelevel = models.CharField(max_length=255, blank=True, null=True)
    highalertvalue = models.CharField(max_length=255, blank=True, null=True)
    created_at = models.CharField(max_length=255, blank=True, null=True)
    def __str__(self):
        return self.spool_name 
    class Meta:
        managed = False
        db_table = 'spool'
        verbose_name_plural = 'Spool'


class Systems(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    sysuniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    sysname = models.CharField(max_length=255)
    sid = models.CharField(max_length=255)
    ostype = models.CharField(max_length=255)
    dbtype = models.CharField(max_length=255)
    ipaddress = models.CharField(max_length=255)
    portnum = models.IntegerField()
    syspassword = models.CharField(max_length=255)
    sitename = models.CharField(max_length=255)
    sitetype = models.CharField(max_length=255)
    siteincharge = models.CharField(max_length=255)
    siteaddress = models.TextField()
    status = models.IntegerField()
    created_at = models.CharField(max_length=255)
    modified_at = models.CharField(max_length=255)
    sub_by = models.CharField(max_length=255)
    def __str__(self):
        return self.sysname
    class Meta:
        managed = False
        db_table = 'systems'
        verbose_name_plural = 'Systems'


class Systemwsdl(models.Model):
    id = models.AutoField(db_column='Id', primary_key=True)  # Field name made lowercase.
    sywsdluniqueid = models.CharField(unique=True, max_length=255)
    customer_id = models.CharField(max_length=255)
    system_id = models.CharField(max_length=255)
    syswsdlurl = models.CharField(max_length=255)
    created_at = models.CharField(max_length=255)
    modified_at = models.CharField(max_length=255)
    sub_by = models.CharField(max_length=255)
    def __str__(self):
        return "WSDL"
    class Meta:
        managed = False
        db_table = 'systemwsdl'
        verbose_name_plural = 'Systems WSDL'
