from requests import Session
from requests.auth import HTTPBasicAuth  # or HTTPDigestAuth, or OAuth1, etc.
from zeep import Client
from zeep.transports import Transport
import xmltodict
import xml.etree.ElementTree as ET
import mysql.connector
import uuid
import datetime
from cryptography.fernet import Fernet
import json

mydb = mysql.connector.connect(
  host = "127.0.0.1",
  user = "Canopus",
  password = "care"
  
)

mycursor = mydb.cursor()


mycursor.execute("use care_new")

key = b'pRmgMa8T0INjEAfksaq2aafzoZXEuwKI7wDe4c1F8AY='

cipher_suite = Fernet(key)

wsdl = []

def WSDL():
    command="SELECT system_id,customer_id,syswsdlurl from systemwsdl where status = 1;"
    mycursor.execute(command)
    myresult = mycursor.fetchall()
    wsdl =[]
    wsdlarray = dict()
    for i in  myresult:
        index = myresult.index(i)
        
        command1 = "SELECT appuid,apppassword,ip from systems_v2 where sysuniqueid='"+i[0]+"';" 
        mycursor.execute(command1)
        myresult1 = mycursor.fetchall()
        pwd = cipher_suite.decrypt(str.encode(myresult1[0][1]))
        fpwd = pwd.decode()
        wsdlarray = {
        "wsdl" : i[2],
        "sid" : myresult1[0][0],
        "pwd" : fpwd,
        "ip" : myresult1[0][2],
        "system_id" : i[0],
        "customer_id" : i[1]

        }
        wsdl.append(wsdlarray)
    
    return wsdl		

def instWSDL():
    command="SELECT system_id,customer_id,instancewsdlurl,insuniqueid,features from instancelist where status = 1;"
    mycursor.execute(command)
    myresult = mycursor.fetchall()
    instwsdl =[]
    wsdlarray = dict()
    # print(myresult)
    for i in  myresult:
        index = myresult.index(i)
        # print(i[0])
        command1 = "SELECT appuid,apppassword,ip,solution_id from systems_v2 where sysuniqueid='"+i[0]+"';" 
        mycursor.execute(command1)
        myresult1 = mycursor.fetchall()
        pwd = cipher_suite.decrypt(str.encode(myresult1[0][1]))

        fpwd = pwd.decode()
        wsdlarray = {
        "wsdl" : i[2],
        "sid" : myresult1[0][0],
        "pwd" : fpwd,
        "ip" : myresult1[0][2],
        "system_id" : i[0],
        "customer_id" : i[1],
        "instance_id" : i[3],
        "features":i[4],
        "solution_id":myresult1[0][3]

        }
        instwsdl.append(wsdlarray)
    return instwsdl	

def Connection(wsdl,adm,pwd):
    session = Session()
    session.auth = HTTPBasicAuth(adm,pwd)
    session.verify = True
    transport = Transport(session=session)
    client = Client(wsdl=wsdl, transport=transport)

    return client


def currentalerts(l):
    for i1 in l:
        try:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            a = client.service.GetAlertTree()
        except:
            continue
        for i in a:
            if i['parent'] ==-1:
                i['parent'] = ""
            
            if i['name'] == None:
                i['name'] = "None"

            if i['parent'] == None:
                i['parent'] = "None"

            if i['ActualValue'] == None:
                i['ActualValue'] = "None"

            if i['description'] == None:
                i['description'] = "None"

            if i['Time'] == None:
                i['Time'] = "None"

            if i['AnalyseTool'] == None:
                i['AnalyseTool'] = "None"

            if i['VisibleLevel'] == None:
                i['VisibleLevel'] = "None"

            if i['HighAlertValue'] == None:
                i['HighAlertValue'] = "None"

            if i['AlDescription'] == None:
                i['AlDescription'] = "None"

            if i['AlTime'] == None:
                i['AlTime'] = "None"

            if i['Tid'] == None:
                i['Tid'] = "None"

        new_a = []
        dictionary = {}
        for i in a:
            dictionary = {}
            dictionary['name'] = i['name']
            dictionary['parent'] = i['parent']
            dictionary['ActualValue'] = i['ActualValue']
            dictionary['description'] = i['description']
            dictionary['Time'] = i['Time']
            dictionary['AnalyseTool'] = i['AnalyseTool']
            dictionary['VisibleLevel'] = i['VisibleLevel']
            dictionary['HighAlertValue'] = i['HighAlertValue']
            dictionary['AlDescription'] = i['AlDescription']
            dictionary['AlTime'] = i['AlTime']
            dictionary['Tid'] = i['Tid']
            new_a.append(dictionary)


        tree = []
        list_ind = []
        for i in new_a:
            ind = new_a.index(i)
            i['Id'] = ind
            list_ind.append(i)

        mappedarr = {}
        for i in list_ind:
            Id  = i['Id']
            if Id not in mappedarr.keys():
                mappedarr[Id] = i
                mappedarr[Id]['children'] = []

            
        for i in mappedarr.keys():
            mappedelement = mappedarr[i]

            if mappedelement['parent']:
                parentid = mappedelement['parent']
                (mappedarr[parentid]['children']).append(mappedelement)

            else:
                tree.append(mappedelement)    

        json_res = json.dumps(tree[1], indent = 4)
        sql = "INSERT INTO alerttree(treeuniqueid,customer_id,system_id,tree,created_at) VALUES(%s, %s,%s, %s,%s)"
        treeuniqueid = uuid.uuid4()
        created_at = datetime.datetime.now()
        value = (treeuniqueid.hex,i1['customer_id'],i1['system_id'],json_res,created_at)
        mycursor.execute(sql,value)
        mydb.commit()			
        # mycursor.close()

def getprocesslist(instw):
    for i in instw:
        try:
            client = Connection(i["wsdl"],i["sid"],i['pwd'])
            a = client.service.GetProcessList()
            sql = "INSERT INTO process_list(processuniqueid,system_id,customer_id,pname,pdesc,dispstatus,stime,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s, %s, %s)"     
            created_at = datetime.datetime.now()
            if a!=None:
                for j in a:
                    name = j['name']
                    description = j['description']
                    dispstatus = j['dispstatus']
                    starttime = j['starttime']
                    if starttime is None:
                        time=0
                    else:	
                        k = starttime.split()
                        l1 = k[0:-1]
                        s = '-'
                        s = s.join(l1)
                        time = s + ' ' + k[-1]
                    
                    
                    processuniqueid = uuid.uuid4()
                    
                    value = (processuniqueid.hex,i['system_id'],i['customer_id'],name,description,dispstatus,time,created_at,i['instance_id'])
                    mycursor.execute(sql,value)
                    mydb.commit()	
        except:
            continue	

def sla(instw):
    for i in instw:
            sysid = i['system_id']
            cusid = i['customer_id']
            insid = i['instance_id']
            solid = i['solution_id']
            try:
                primaryidcmd = "SELECT max(id) from sla where instance_id = '"+insid+"';"

                mycursor.execute(primaryidcmd)
                myresult = mycursor.fetchall()
                pkey = myresult[0][0]

                countcmd = "SELECT * from sla where id = '"+str(pkey)+"';" 
                mycursor.execute(countcmd)
                myresult1 = mycursor.fetchall()
                count = myresult1[0][8]
                created_at = myresult1[0][11]
                modified_at = datetime.datetime.now()
                
                slastatus = myresult1[0][4]
                stime = myresult1[0][5]
                etime = myresult1[0][6]
                try:
                    client = Connection(i["wsdl"],i["sid"],i['pwd'])
                    a = client.service.ReadDeveloperTrace(filename = "available.log",size = 0)
                except:
                    continue
                available_log_list = a['lines']['item']
                if len(available_log_list) == count:
                    
                    slauniqueid = uuid.uuid4()
                    sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
                    value = (slauniqueid.hex,cusid,sysid,slastatus,etime,modified_at,created_at,count,insid,solid,modified_at)
                    # print("No Change")
                    # print(value)
                    mycursor.execute(sql,value)
                    mydb.commit()
                elif len(available_log_list) > count:
                    slauniqueid = uuid.uuid4()
                    log = a['lines']['item'][count-1]
                    temp_log_list = log.split()
                    temp_etime = temp_log_list[-2] + ' ' + temp_log_list[-1]
                    sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
                    value = (slauniqueid.hex,cusid,sysid,slastatus,etime,temp_etime,created_at,count,insid,solid,modified_at)
                    # print("Change 1st entry")
                    # print(value)
                    mycursor.execute(sql,value)
                    mydb.commit()				
                    for i in a['lines']['item'][count:]:
                        uid = uuid.uuid4()
                        temp_lodg_list_1 = i.split()
                        stime1 = temp_lodg_list_1[1] + ' ' + temp_lodg_list_1[2]
                        etime1 = temp_lodg_list_1[-2] + ' ' + temp_lodg_list_1[-1]
                        count1 = (a['lines']['item']).index(i) 
                        sql1 = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,created_at,count,instance_id,solution_id,modified_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)" 
                        value1 = (uid.hex,cusid,sysid,temp_lodg_list_1[0],stime1,etime1,created_at,count1 + 1,insid,solid,modified_at)
                        # print("Change rest of the entries")
                        # print(value1)
                        mycursor.execute(sql1,value1)
                        mydb.commit()
            except:
                continue       					

def onetimesla(instw):
    for i in instw:
            sysid = i['system_id']
            cusid = i['customer_id']
            insid = i['instance_id']
            solid = i['solution_id']
            client = Connection(i["wsdl"],i["sid"],i['pwd'])
            try:
                a = client.service.ReadDeveloperTrace(filename = "available.log",size = 0)
                created_at = datetime.datetime.now()
            except:
                continue
            for i in a['lines']['item']:
                uid = uuid.uuid4()
                l = i.split()
                stime = l[1] + ' ' + l[2]
                etime = l[-2] + ' ' + l[-1]
                sql = "INSERT INTO sla(slauniqueid,customer_id,system_id,slastatus,stime,etime,modified_at,count,instance_id,solution_id,created_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s,%s,%s,%s)"
                count = ((a['lines']['item']).index(i))+1
                value = (uid.hex,cusid,sysid,l[0],stime,etime,created_at,count,insid,solid,created_at)
                mycursor.execute(sql,value)
                mydb.commit()


def heartbeat(wsdl):
    for i1 in wsdl:
        try:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            currentalerts = client.service.GetAlertTree()
        except:
            continue
        up = 0
        down = 0
        partially = 0
        status = 1
        if len(currentalerts) > 0:
            a = client.service.GetSystemInstanceList()
            for i in a:
                if i['dispstatus'] == 'SAPControl-GREEN':
                    up = up + 1
                elif i['dispstatus'] == 'SAPControl-YELLOW':
                    partially = partially + 1

                elif i['dispstatus'] == 'SAPControl-GRAY':
                    down = down + 1
            if (partially==0) and (up==0):
                status = 0
            elif (down==0) and (partially==0):
                status = 1
            else:
                status =2
            modified_at = datetime.datetime.now()
            sql = "UPDATE systems_v2 SET modified_at=%s,status=%s  WHERE sysuniqueid=%s"
            value = (modified_at, status, i1['system_id'])
            mycursor.execute(sql,value)			
            mydb.commit()

def instanceheartbeat(instw):
    for i1 in instw:
        status = 0
        try:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            currentalerts = client.service.GetAlertTree()
        except:
            continue
        portsql = "select http_port from instancelist where insuniqueid ='"+i1["instance_id"]+"';"
        mycursor.execute(portsql)
        myresult = mycursor.fetchall()		
        if len(currentalerts) > 0:
            a = client.service.GetSystemInstanceList()
            for i in a:
                if i['httpPort'] == myresult[0][0]:
                    if i['dispstatus'] == 'SAPControl-GREEN':
                        status = 1
                    elif i['dispstatus'] == 'SAPControl-YELLOW':
                        status = 2
                    elif i['dispstatus'] == 'SAPControl-GRAY':
                        status = 0
            created_at = datetime.datetime.now()
            sql = "UPDATE instancelist SET created_at=%s,status=%s  WHERE insuniqueid=%s"
            value = (created_at, status, i1['instance_id'])
            mycursor.execute(sql,value)			
            mydb.commit()


def currentalerts_generic(l):
    list_trees = []
    for i1 in l:
        print(i1["wsdl"],i1["sid"],i1['pwd'])
        try:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            a = client.service.GetAlertTree()
        except:
            continue
        for i in a:
            if i['parent'] ==-1:
                i['parent'] = ""
            
            if i['name'] == None:
                i['name'] = "None"

            if i['parent'] == None:
                i['parent'] = "None"

            if i['description'] == None:
                i['description'] = "None"

        new_a = []
        dictionary = {}
        for i in a:
            dictionary = {}
            dictionary['name'] = i['name']
            dictionary['parent'] = i['parent']
            dictionary['description'] = i['description']

            new_a.append(dictionary)


        tree = []
        list_ind = []
        for i in new_a:
            ind = new_a.index(i)
            i['Id'] = ind
            list_ind.append(i)

        mappedarr = {}
        for i in list_ind:
            Id  = i['Id']
            if Id not in mappedarr.keys():
                mappedarr[Id] = i
                mappedarr[Id]['children'] = []

            
        for i in mappedarr.keys():
            mappedelement = mappedarr[i]

            if mappedelement['parent']:
                parentid = mappedelement['parent']
                (mappedarr[parentid]['children']).append(mappedelement)

            else:
                tree.append(mappedelement)  
        tree.append(i1) 
        list_trees.append(tree) 
    return list_trees       

def fs(list_trees):
    for i1 in list_trees:
        for i in i1[1]['children']:
            if i['name'] == 'Filesystems':
                created_at = datetime.datetime.now()	
                for j in i['children']:
                    fsuniqueid = uuid.uuid4()	
                    obj = []			
                    for k in j['children']:  	
                        obj.append(k['description'])
                    sql = "INSERT INTO fsmonitoring(fsmonitoringuniqueid,customer_id,system_id,filesys,free,perc,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s,%s)"
                    value = (fsuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],obj[0],obj[1],obj[2],created_at,i1[-1]['instance_id'])
                    mycursor.execute(sql,value)
                    mydb.commit()


def cpu(list_trees):						
    for i1 in list_trees:
        for i in i1[1]['children']:
            if i['name']=='CPU':
                created_at = datetime.datetime.now()
                for j in i['children']:
                    metric = j['name']
                    value = j['description']
                    cpuuniqueid = uuid.uuid4()
                    sql = "INSERT INTO cpumonitoring(cpumonitoringuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s)"
                    insert_value = (cpuuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],metric,value,created_at,i1[-1]['instance_id'])
                    mycursor.execute(sql,insert_value)
                    mydb.commit()
        
def mem(list_trees):						
    for i1 in list_trees:
        for i in i1[1]['children']:
            if i['name']=='Memory':
                created_at = datetime.datetime.now()
                for j in i['children']:
                    metric = j['name']
                    value = j['description']
                    memuniqueid = uuid.uuid4()
                    sql = "INSERT INTO memorymonitoring(memorymonitoringuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s,%s)"					
                    insert_value = (memuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],metric,value,created_at,i1[-1]['instance_id'])
                    mycursor.execute(sql,insert_value)
                    mydb.commit()

def workprocess(wsdl):
    for i1 in wsdl:
        try:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            a = client.service.ABAPGetSystemWPTable()
            created_at = datetime.datetime.now()
            for i in a:
                wpuniqueid = uuid.uuid4()
                Instance = i['Instance']
                No = i['No']
                Typ = i['Typ']
                Status = i['Status']
                Reason = i['Reason']
                Start = i['Start']
                Err = i['Err']
                Sem = i['Sem']
                Cpu = i['Cpu']
                Time = i['Time']
                Program = i['Program']
                Client = i['Client']
                User = i['User']
                Action = i['Action']
                Table = i['Table']
                sql = "INSERT INTO workprocessmonitoring(wpuniqueid,customer_id,system_id,Instance,No,Typ,Status,Reason,Start,Err,sem,cpu,wptime,program,client,user,action,wptable,created_at) VALUES(%s, %s,%s, %s,%s, %s,%s,%s, %s,%s, %s,%s, %s,%s,%s, %s,%s, %s,%s)"
                value = (wpuniqueid.hex,i1['customer_id'],i1['system_id'],Instance,No,Typ,Status,Reason,Start,Err,Sem,Cpu,Time,Program,Client,User,Action,Table,created_at)
                mycursor.execute(sql,value)
                mydb.commit()
        except:
            continue
        

def runtimedumps(list_trees):
    for i1 in list_trees:
        created_at = datetime.datetime.now()
        for i in i1[5]['children']:
            dumpsuniqueid = uuid.uuid4()
            metric = i['name']
            value = i['description']
            sql = "INSERT INTO runtimedumps(dumpsuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s)"
            sql_value = (dumpsuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],metric,value,created_at,i1[-1]['instance_id'])
            mycursor.execute(sql,sql_value)
            mydb.commit()

def responsetime(list_trees):
    for i1 in list_trees:
        created_at = datetime.datetime.now()
        for i in i1[3]['children']:
            if i['name'] == 'Dialog':
                for j in i['children']:
                    responsetimeuniqueid = uuid.uuid4()
                    metric = j['name']
                    value = j['description']
                    sql = "INSERT INTO responsetimes(resuniqueid,customer_id,system_id,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s)"
                    sql_value =(responsetimeuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],metric,value,created_at,i1[-1]['instance_id'])
                    mycursor.execute(sql,sql_value)
                    mydb.commit()	

def update(list_trees):
    for i1 in list_trees:
        created_at = datetime.datetime.now()
        for i in i1[3]['children']:
            if i['name'] == 'Update':
                for j in i['children']:
                    updatetype = j['name']
                    for k in j['children']:
                        updateuniqueid = uuid.uuid4()
                        metric = k['name']					
                        value = k['description']
                        sql = "INSERT INTO updatemonitoring(updateuniqueid,customer_id,system_id,updatetype,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
                        sql_value = (updateuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],updatetype,metric,value,created_at,i1[-1]['instance_id'])
                        mycursor.execute(sql,sql_value)
                        mydb.commit()
        
def buffer(list_trees):
    for i1 in list_trees:
        created_at = datetime.datetime.now()
        for i in i1[4]['children']:
            if i['name'] == 'Buffers':
                for j in i['children']:
                    buffertype = j['name']
                    for k in j['children']:
                        bufferuniqueid = uuid.uuid4()
                        metric = k['name']
                        value = k['description']
                        sql = "INSERT INTO buffer(bufferuniqueid,customer_id,system_id,buffertype,metric,value,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s)"
                        sql_value = (bufferuniqueid.hex,i1[-1]['customer_id'],i1[-1]['system_id'],buffertype,metric,value,created_at,i1[-1]['instance_id'])		
                        mycursor.execute(sql,sql_value)
                        mydb.commit()


def enquelocks(instw_enque):
    # try:

        for i1 in instw_enque:
            client = Connection(i1["wsdl"],i1["sid"],i1['pwd'])
            with client.settings(raw_response=True):

                a = client.service.EnqGetLockTable()
                # print(etree.tostring(a.content.decode('utf-8'), encoding="unicode", pretty_print=True))
                # print(a.content.decode('utf-8').replace("￿",''))
                # tree = ET.ElementTree(ET.fromstring(a.content.decode('utf-8')))
                # print(tree)
                # print(type(tree))
                created_at = datetime.datetime.now()
                a_dict = xmltodict.parse(a.content.decode("utf-8").replace("￿",'').replace("null",""))
                # print(a_dict['SOAP-ENV:Envelope']['SOAP-ENV:Body'].keys())
                try:

                    for i in a_dict['SOAP-ENV:Envelope']['SOAP-ENV:Body']['SAPControl:EnqGetLockTableResponse']['lock']['item']:
                        
                        lockname = i['lock-name']
                        # print(lockname)			
                        lockarg = i['lock-arg']
                        client = i['client']
                        user = i['user']
                        obj = i['object']
                        enquelocksuniqueid = uuid.uuid4()
                        sql = "INSERT INTO enquelocksmonitoring(enquelocksuniqueid,customer_id,system_id,lockname,lockarg,client,user,object1,created_at,instance_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s)"	
                        sql_value = (enquelocksuniqueid.hex,i1['customer_id'],i1['system_id'],lockname,lockarg,client,user,obj,created_at,i1['instance_id'])
                        # print(sql_value)
                        mycursor.execute(sql,sql_value)
                        mydb.commit()
                except KeyError:
                    continue
    # except:
    #     print("error")			


def J2EEGetProcessList2(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetProcessList2()
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['state','telnetPort']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetprocesslist2(name,pid,type,restart,exitCode,statetext,startTime,elapsedTime,restartCount,errorCount,cpu,debug,clusterId,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s,%s,%s,%s)"	
                    sql_value = (i_dict[0][1]['name'],i_dict[0][1]['pid'],i_dict[0][1]['type'],i_dict[0][1]['restart'],i_dict[0][1]['exitCode'],i_dict[0][1]['statetext'],i_dict[0][1]['startTime'],i_dict[0][1]['elapsedTime'],i_dict[0][1]['restartCount'],i_dict[0][1]['errorCount'],i_dict[0][1]['cpu'],i_dict[0][1]['debug'],i_dict[0][1]['clusterId'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()
    # except Exception as err:
    #     print(err)

def J2EEGetThreadList2(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetThreadList2()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['updateTime','dispstatus', 'index']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetthreadlist2(processname,startTime,taskupdateTime,subtaskupdateTime,task,subtask,name,classname,user,pool,state,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"	
                    sql_value = (i_dict[0][1]['processname'],i_dict[0][1]['startTime'],i_dict[0][1]['taskupdateTime'],i_dict[0][1]['subtaskupdateTime'],i_dict[0][1]['task'],i_dict[0][1]['subtask'],i_dict[0][1]['name'],i_dict[0][1]['classname'],i_dict[0][1]['user'],i_dict[0][1]['pool'],i_dict[0][1]['state'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()
    # except Exception as err:
    #     print(err)

def J2EEGetSessionList(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetSessionList()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                # if not key in ['updateTime','dispstatus', 'index']:
                created_at = datetime.datetime.now()
                result_dict[key] = i_dict[0][1][key]
                sql = "INSERT INTO j2eegetsessionlist(processname,IdHash,size,timeout,activeRequests,startTime,updateTime,sticky,corrupt,backingStore,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"	
                sql_value = (i_dict[0][1]['processname'],i_dict[0][1]['IdHash'],i_dict[0][1]['size'],i_dict[0][1]['timeout'],i_dict[0][1]['activeRequests'],i_dict[0][1]['startTime'],i_dict[0][1]['updateTime'],i_dict[0][1]['sticky'],i_dict[0][1]['corrupt'],i_dict[0][1]['backingStore'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                # print(sql_value)
                mycursor.execute(sql,sql_value)
                mydb.commit()            
        
    # except Exception as err:
    #     print(err)

def J2EEGetWebSessionList(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetWebSessionList()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                # if not key in ['updateTime','dispstatus', 'index']:
                created_at = datetime.datetime.now()
                result_dict[key] = i_dict[0][1][key]
                sql = "INSERT INTO j2eegetwebsessionlist(processname,IdHash,size,timeout,activeRequests,startTime,updateTime,state,user,backingStore,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s,%s,%s)"	
                sql_value = (i_dict[0][1]['processname'],i_dict[0][1]['IdHash'],i_dict[0][1]['size'],i_dict[0][1]['timeout'],i_dict[0][1]['activeRequests'],i_dict[0][1]['startTime'],i_dict[0][1]['updateTime'],i_dict[0][1]['state'],i_dict[0][1]['user'],i_dict[0][1]['backingStore'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                # print(sql_value)
                mycursor.execute(sql,sql_value)
                mydb.commit()             
        
    # except Exception as err:
    #     print(err)

def J2EEGetCacheStatistic2(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetCacheStatistic2()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetcachestatistic2(description,owner,type,size,attrSize,keysSize,cachedObjects,usedObjects,puts,gets,hits,removes,changes,evictions,instanceInvalidations,clusterInvalidations,updateTime,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s, %s, %s, %s,%s, %s, %s, %s, %s, %s,%s,%s)"	
                    sql_value = (i_dict[0][1]['description'],i_dict[0][1]['owner'],i_dict[0][1]['type'],i_dict[0][1]['size'],i_dict[0][1]['attrSize'],i_dict[0][1]['keysSize'],i_dict[0][1]['cachedObjects'],i_dict[0][1]['usedObjects'],i_dict[0][1]['puts'],i_dict[0][1]['gets'],i_dict[0][1]['hits'],i_dict[0][1]['removes'],i_dict[0][1]['changes'],i_dict[0][1]['evictions'],i_dict[0][1]['instanceInvalidations'],i_dict[0][1]['clusterInvalidations'],i_dict[0][1]['updateTime'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()              
        
    # except Exception as err:
    #     print(err)

def J2EEGetComponentList(i):
    try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetComponentList()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                # if not key in ['updateTime','dispstatus', 'index']:
                created_at = datetime.datetime.now()
                result_dict[key] = i_dict[0][1][key]
                sql = "INSERT INTO j2eegetcomponentlist(type,name,startupmode,status,expectedstatus,details,dispstatus,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"	
                sql_value = (i_dict[0][1]['type'],i_dict[0][1]['name'],i_dict[0][1]['startupmode'],i_dict[0][1]['status'],i_dict[0][1]['expectedstatus'],i_dict[0][1]['details'],i_dict[0][1]['dispstatus'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                # print(sql_value)
                mycursor.execute(sql,sql_value)
                mydb.commit()              
        
    except Exception as err:
        print(err)

def J2EEGetVMHeapInfo(i):
    try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetVMHeapInfo()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetvmheapinfo(processname,type,size,commitSize,maxUsedSize,initialSize,maxSize,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"	
                    sql_value = (i_dict[0][1]['processname'],i_dict[0][1]['type'],i_dict[0][1]['size'],i_dict[0][1]['commitSize'],i_dict[0][1]['maxUsedSize'],i_dict[0][1]['initialSize'],i_dict[0][1]['maxSize'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()                   
            
    except Exception as err:
        print(err)

def J2EEGetVMGCHistory2(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetVMGCHistory2()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetvmgchistory2(processname,type,reason,startTime,duration,cpuTime,objBytesBefore,objBytesAfter,objBytesFreed,clsBytesBefore,clsBytesAfter,clsBytesFreed,heapSize,unloadedClasses,pageFaults,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s, %s, %s, %s, %s,%s, %s,%s, %s, %s, %s, %s,%s,%s)"	
                    sql_value = (i_dict[0][1]['processname'],i_dict[0][1]['type'],i_dict[0][1]['reason'],i_dict[0][1]['startTime'],i_dict[0][1]['duration'],i_dict[0][1]['cpuTime'],i_dict[0][1]['objBytesBefore'],i_dict[0][1]['objBytesAfter'],i_dict[0][1]['objBytesFreed'],i_dict[0][1]['clsBytesBefore'],i_dict[0][1]['clsBytesAfter'],i_dict[0][1]['clsBytesFreed'],i_dict[0][1]['heapSize'],i_dict[0][1]['unloadedClasses'],i_dict[0][1]['pageFaults'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()                               
        
    # except Exception as err:
    #     print(err)

def J2EEGetSharedTableInfo(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetSharedTableInfo()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    sql = "INSERT INTO j2eegetsharedtableinfo(table_info,used,peak,limit_info,system_id,instance_id,created_at,customer_id) VALUES(%s, %s,%s, %s,%s, %s,%s,%s)"	
                    sql_value = (i_dict[0][1]['table'],i_dict[0][1]['used'],i_dict[0][1]['peak'],i_dict[0][1]['limit'],i['system_id'],i['instance_id'],created_at,i['customer_id'])
                    # print(sql_value)
                    mycursor.execute(sql,sql_value)
                    mydb.commit()                 
        
    # except Exception as err:
    #     print(err)

def J2EEGetClusterMsgList(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetClusterMsgList()
        # print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    # sql = "INSERT INTO j2eegetclustermsglist() VALUES()"	
                    # sql_value = ()
                    # # print(sql_value)
                    # mycursor.execute(sql,sql_value)
                    # mydb.commit()               
        
    # except Exception as err:
    #     print(err)

def J2EEGetThreadCallStack(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetThreadCallStack()
        print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    # sql = "INSERT INTO j2eegetthreadcallstack() VALUES()"	
                    # sql_value = ()
                    # # print(sql_value)
                    # mycursor.execute(sql,sql_value)
                    # mydb.commit()             
        
    # except Exception as err:
    #     print(err)

def J2EEGetThreadTaskStack(i):
    # try:
        client = Connection(i["wsdl"],i["sid"],i['pwd'])
        a = client.service.J2EEGetThreadTaskStack()
        print(a)
        for j in a:
            result_dict = {}
            i_dict = list(j.__dict__.items())
            for key in i_dict[0][1].keys(): 
                if not key in ['dispstatus']:
                    created_at = datetime.datetime.now()
                    result_dict[key] = i_dict[0][1][key]
                    # sql = "INSERT INTO j2eegetthreadtaskstack() VALUES()"	
                    # sql_value = ()
                    # # print(sql_value)
                    # mycursor.execute(sql,sql_value)
                    # mydb.commit()             
        
    # except Exception as err:
    #     print(err)


l = WSDL()
instw = instWSDL()
list_trees = currentalerts_generic(instw)
workprocess(l)
fs(list_trees)
cpu(list_trees)
mem(list_trees)
sla(instw)
getprocesslist(instw)
currentalerts(l)
onetimesla(instw)
heartbeat(l)
instanceheartbeat(instw)
instw_abap = []
instw_enque = []

# print(instw)
for i in instw:
    s = i['features'].split('|')
    if 'ABAP' in s:
        instw_abap.append(i)
    elif 'ENQUE' in s:
        instw_enque.append(i)

for i in instw:
    mycursor.execute('select instancetype from systems_v2 where sysuniqueid="'+i['system_id']+'"' )
    if mycursor.fetchall()[0][0]=="java_application":
        J2EEGetProcessList2(i)
        J2EEGetThreadList2(i)
        J2EEGetSessionList(i)
        J2EEGetWebSessionList(i)
        J2EEGetCacheStatistic2(i)
        J2EEGetComponentList(i)
        J2EEGetVMHeapInfo(i)
        J2EEGetVMGCHistory2(i)
        J2EEGetSharedTableInfo(i)
        # J2EEGetClusterMsgList(i)
        # J2EEGetThreadCallStack(i)
        # J2EEGetThreadTaskStack(i)
    else:
        continue

enquelocks(instw_enque)
list_trees_abap = currentalerts_generic(instw_abap)     

buffer(list_trees_abap)
runtimedumps(list_trees_abap)
responsetime(list_trees_abap)
update(list_trees_abap)



